(*-----------#pc-version-----------------------------------------------------*)

{$N+,O+,F+,E+}
(*
unit mon;
interface
uses tt1,tt2,tt3,tt4,tt5;
*)
(*-----------#pc-version-----------------------------------------------------*)

const
     maxsymverts = 10;
type
     catnumarray = array[1..maxvertex,1..maxcategories] of integer;
     parrecord = record
        numprev: integer;
        parn: array[1..maxvertex] of integer;
        parv: array[1..maxvertex] of real;
      end;
    lscoretype = array[1..maxvertex] of real;


var
(*	varcatvalue is the variable in which we keep value for each category
	ie varcatvalue[i,j] is the value of category j of variable i  *)
   varcatvalue:catnumarray;
   smeans: vertarray;
   scov, truecov, scor, truecor: covarray;
   parmsfixed, standardassumpts,undercontinuous : boolean;
   prnton: boolean;
   newseed, oldseed : integer;
   outfilename, curoutfilename,coeffilename, bfilename: inbuf;
   exogd: exogarray;
   lowparm, highparm : real;
   percentneg : integer;
   lscorearr: lscoretype;
   minternal: boolean;
   datatypes: numberset;
   cp		    : modeltypeptr;
   tempcats: categoryarray;
   haslatentpar: vertexset;
   mydebug: boolean;

procedure domonte; external;
function randunif(lower, upper: real): real; external;
function getnumcat(vert: vertextype; value: real; var cats:categoryarray): integer;external;
procedure findcondprob(var cur: probptr; effect: vertextype; var cutoffs: probarray; 
                       var cats:categoryarray; var varval: vertarray);external;
procedure getdiscreteval(effect: vertextype; var varval: vertarray;
                         var cats: categoryarray);external;
procedure formeqsorder(var cureqs: eqorder; var graph: adjtype); external;
procedure doestimate(var adjacency: adjtype; var outfile: text;
                     minternal: boolean;estmethod:esttype;precision:integer); external;
procedure writediscretemodel(var cats: categoryarray; var eqs: eqorder; 
                             var graph: adjtype; var outfile: text; default: boolean); external;
procedure monteinit;external;
procedure disposepointrs(var tiers: tiersptr; var varorder: eqorder); external;
procedure getbayesparms(var cats: categoryarray; cureqs: eqorder;
                        fixed: boolean; var infile: text); external;
procedure getcategories(var cats: categoryarray); external;
procedure getscore(var lambda,score: real); external;
procedure getcauses(vert : vertextype; var graph: adjtype;
                    var causes: relationsets);external;
procedure disposebayesnet(var cats: categoryarray); external;
procedure rearrange(var localadj,adjacency: adjtype; 
                    var localnames,vernames: namearray);external;
procedure readcategories(var cats: categoryarray; 
                         var eqs: eqorder; var bfin: text);external;
procedure getmodscore(var lambda,locscore: real; v: vertextype);external;
procedure zdisposebayesnet(var cats: categoryarray);external;
procedure clearcats;external;
procedure fillouttree(var category: categoryarray;estmethod:esttype;precision:integer);external;
procedure formtree(var adjacency: adjtype; var category: categoryarray);external;
procedure disposeeqsorder(var eqs: eqorder);external;
function gammln(xx: real): real; external;

procedure entropyscore(var lscore:real);external;
procedure entropymodscore(var locscore: real; v: vertextype);external;
procedure writeequation(var outfile: text; var cureqs: eqorder;
                        var graph: adjtype; var curparm: covarray);external;
function randnorm(mean, variance: real): real;external;
procedure writemat(mat : covarray; var outfile : text; datatype: integer);external;
procedure formtrue(var impcov: covarray; needtiers,needtreks: boolean);external;
procedure getsamplecov(var scov: covarray);external;
function randlognorm(median, variance: real): real; external;
procedure formbranch(var adjacency: adjtype; var category: categoryarray;
                     i: vertextype); external;

