(*-----------#pc-version-----------------------------------------------------*)

{$N+,E+,F+,O+}
(*
unit calctet;
interface
uses tt1,tt2,tt3,tt4,tt5;
*)
(*-----------#pc-version-----------------------------------------------------*)

var     paths1: pathstype;            { path matrix }
        treks1: trekstype;             { trek matrix }
        adjacency,forbiddenadj,commonfor: adjtype;      
        rho,cov,parm: covarray;

(* procedure disposeimpldptrs; *)
  (* This procedure destroys the impld pointer at the
     conclusion of processing a graph, so that cycling
     for a new graph won't keep accumumlating garbage in memory.  *)
procedure calctrek(var trek: trekstype; paths: pathstype; level: integer);external;
procedure getprob(var a: real; gamma: real);external;
function plus(path1,path2: pathsptr): pathsptr; external;
procedure comparepair(i,j,k,l,pattern,level: integer; var now: boolean); external;
procedure update(localimp: implist; singleedge: boolean; locresid: real;
                 var chimpheld,chimpnheld: real); external;
procedure calcstat(a,b,c,d: integer; locresid: real; var prob: real;
	           pattern: integer); external;
procedure outputres(a1,b1,c1,d1,a2,b2,c2,d2: integer; prob,locresid: real;
	 	   isimplied,isheld: boolean); external;
procedure addedge(head,tail: edge; var treks: trekstype; 
	          var paths: pathstype; depth: integer;
                  var corrlast: integer; var chimpheld,chimpnheld: real); external;
function timesc(paths1,paths2: pathsptr; depth: integer; vert: vertextype;
                neededges: boolean): pathsptr; external;
function plusc(paths1,paths2: pathsptr; level: integer): pathsptr; external;

