
type
  sampletype = (train,test,est,trainest,ignore);
  sampletypearray = array[1..maxsamp] of sampletype;
  predrec = record
            cat:integer;
            prob:real;
            end;
  predarraytype = array[1..(2*maxsamp)] of predrec;

var
  predarray:predarraytype;
  samparray : sampletypearray;
  trainsize : integer;
  estimatesize :integer;
  testsize :integer;

  falsepos: integer;
  falseneg: integer;
  truepos: integer;
  trueneg: integer;
  crosscutoff:real;

  classvar: vertextype;
  classvalue: integer;
  classname:vertexnametype;			{the name of the variable to classfy}
  testlow, testhigh, estlow, esthigh, trainlow, trainhigh: integer;
  trainandest : boolean;

procedure initsamparray(var samparray:sampletypearray); external;
procedure setupsamparray(var samparray:sampletypearray; testlow, testhigh, estlow, esthigh, buildlow, buildhigh: integer); external;
procedure dosplit; external;
procedure docrossvalidate; external;
procedure doautocrossvalidate(poscat: integer; var curmodel: modeltypeptr;
pospercent,percentpop: real; estimate: esttype; maxtype: infotype); external;
function findpvalueforpositive(classvar,poscat:integer):real;external;
procedure getposcat(classvar:vertextype; var poscat:integer); external;
procedure printstats(var ofile:text; var curmodel: modeltypeptr); external;
procedure comparemodel(var bestmodel,curmodel: modeltypeptr; maxtype: infotype;printmod:boolean);external;

procedure makerocfile;external;
procedure dogetbestacc;external;
procedure copymodel(var frommodel,tomodel: modeltypeptr); external;
procedure writemodel(var ofile: text; amodel: modelt);external;
