#include "syst.h"
#include "tt1.h"
#include "tt2.h"
#include "tt3.h"
#include "tt4.h"
#include "tt5.h"
#include "util.h"
#include "io.h"
#include "init.h"
#include "sys.h"

program tetrad(input,output);


begin
   writeln;
   writeln('                    TETRAD - Version 3.0');
   writeln('                Beta Version - October, 1996');
   writeln('                    COPYRIGHT (C) 1996 by');
   writeln('        Peter Spirtes, Richard Scheines, Clark Glymour');
   writeln('           Christopher Meek, Thomas Richardson,');
   writeln('           Herbert Hoijtink, and Anne Boomsma');
   writeln;
   writeln;
   writeln('For help, type "help"');
   sysinit;
   setupargs;
   if gui then
	while (currentargnum <= maxargnum) do
	   begin
	       write('>'); 
	       readttyline(buf); 
	       execcommand(parsecommand(false)); 
	   end
    else
     begin
	initialize;
	 repeat
	       write('>'); 
	       readttyline(buf); 
	       execcommand(parsecommand(false)); 
	 until wantexit; 
      end;
end.

